> For the complete documentation index, see [llms.txt](https://docs.bluestorm.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.bluestorm.io/checks/component/comp_0014.md).

# Component upgrade effort

| Check ID | COMP\_0014                                                                                                                                                                                                                                                                                                                                                                                               |
| -------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| Category | Maintainability                                                                                                                                                                                                                                                                                                                                                                                          |
| Summary  | This check estimates the development effort, in hours, needed to bring the runtime and the components used by your app up to the latest supported version. The estimate is based on how often and where each component is used in your app, its support status, and how many versions it is behind. The total effort is converted into calendar weeks, and this determines the risk level of the result. |
| Options  | The calculation is based on default values that you can adjust to match your own team and way of working. See the tables below for all available options.                                                                                                                                                                                                                                                |
| Pass     | No component in your app needs to be upgraded, adapted or replaced.                                                                                                                                                                                                                                                                                                                                      |
| Fail     | One or more components need to be upgraded, adapted or replaced. The risk level (Low, Medium or High) depends on the total estimated effort for the app.                                                                                                                                                                                                                                                 |

{% hint style="info" %}
The option 'Ignore Marketplace Modules' has no effect on this policy check. Because the purpose of this  policy check is the assess the upgrade effort for used Marketplace modules, this setting will always be ignored by the system.
{% endhint %}

### Base Element Effort

The base hours needed to fix one usage of a component in another module. The effort for a component is calculated from how often each of these elements uses it.

| Option Name                       | Details                                                                                                 |
| --------------------------------- | ------------------------------------------------------------------------------------------------------- |
| Actions (Microflow/Nanoflow/Rule) | Base hours to fix one cross-module usage of a microflow, nanoflow or rule. Default: 0.6                 |
| Java Actions                      | Base hours to fix one cross-module usage of a Java action. Default: 1.0                                 |
| Pages                             | Base hours to fix one widget placement on a page in another module. Default: 0.3                        |
| Entity Used in Microflow          | Base hours to fix one Create/Change usage of an entity in another module's microflow. Default: 0.8      |
| Entity Used on Page               | Base hours to fix one usage of an entity on a page in another module. Default: 0.4                      |
| Entity Inheritance                | Base hours to fix one entity in another module that inherits from this component's entity. Default: 2.0 |

### Effort Mode Multipliers

| Option Name            | Details                                                                                                                                                                  |
| ---------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| Adapt Multiplier       | Multiplier applied to element effort when a component has a supported status but is behind by a major version. Default: 1.5                                              |
| Replace Multiplier     | Multiplier applied to element effort when a component is deprecated and must be replaced. Default: 2.5                                                                   |
| Replace Discovery Cost | Fixed hours per component for finding, validating and configuring a replacement. This is added once for each component, regardless of how often it is used. Default: 6.0 |

### Breakage Probability

| Option Name                      | Details                                                                                 |
| -------------------------------- | --------------------------------------------------------------------------------------- |
| Breakage Probability - Patch (%) | Percentage of usages estimated to need a fix for each patch version behind. Default: 7  |
| Breakage Probability - Minor (%) | Percentage of usages estimated to need a fix for each minor version behind. Default: 25 |
| Breakage Probability - Major (%) | Percentage of usages estimated to need a fix for each major version behind. Default: 75 |

### Mendix Runtime Effort

| Option Name                         | Details                                                                                                                       |
| ----------------------------------- | ----------------------------------------------------------------------------------------------------------------------------- |
| Runtime Base Effort                 | Base hours for a Mendix runtime version upgrade, before the distance multiplier is applied. Default: 8.0                      |
| Runtime Distance Multiplier - Patch | Multiplier applied to the runtime base effort when the current version is only patch versions behind the latest. Default: 1.0 |
| Runtime Distance Multiplier - Minor | Multiplier applied to the runtime base effort when the current version is minor versions behind the latest. Default: 1.8      |
| Runtime Distance Multiplier - Major | Multiplier applied to the runtime base effort when the current version is major versions behind the latest. Default: 3.5      |

### Support Status Weight (Mendix Runtime)

The urgency weight for the Mendix runtime, based on its support status.

| Option Name | Details                                                                                          |
| ----------- | ------------------------------------------------------------------------------------------------ |
| LTS         | Urgency weight for a Long Term Support release. Default: 1.0                                     |
| MTS         | Urgency weight for a Medium Term Support release. Default: 1.2                                   |
| Supported   | Urgency weight for a Supported (non-LTS/MTS) release. Default: 1.3                               |
| Deprecated  | Urgency weight for a Deprecated or withdrawn release. Default: 1.3                               |
| Unknown     | Urgency weight when the support status could not be determined from the repository. Default: 1.4 |

### Support Status Weight (Standard Components)

The urgency weight for modules, widgets and other components that are not the Mendix runtime, based on their support status.

| Option Name | Details                                                                                                               |
| ----------- | --------------------------------------------------------------------------------------------------------------------- |
| Supported   | Urgency weight for a component that is platform supported. Default: 1.0                                               |
| Community   | Urgency weight for a component that is community supported, with no guaranteed support. Default: 1.6                  |
| Deprecated  | Urgency weight for a component that is marked end-of-life and is due to be dropped to Community support. Default: 2.5 |
| Unknown     | Urgency weight when the support status could not be determined from the repository. Default: 1.8                      |

### Version Distance Weight (Urgency)

| Option Name           | Details                                                                                    |
| --------------------- | ------------------------------------------------------------------------------------------ |
| Patch Versions Behind | Urgency weight applied for each patch version behind the latest. Default: 1.0              |
| Minor Versions Behind | Urgency weight applied for each minor version behind the latest, compounding. Default: 1.3 |
| Major Versions Behind | Urgency weight applied for each major version behind the latest, compounding. Default: 2.2 |

### App Risk Thresholds

The total effort for an app is converted into calendar weeks, based on the size and weekly capacity of your team. The result is compared to the thresholds below to set the risk level.

| Option Name                   | Details                                                                                                                                                                   |
| ----------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| Available Developers          | The number of developers that are assumed to be able to work on the upgrades of this app in parallel. Default: 2                                                          |
| Hours per Developer per Week  | The working hours per developer per week that are used to convert the total effort into calendar weeks. Default: 40                                                       |
| Low Risk Threshold (weeks)    | If the total effort is at or below this number of calendar weeks, the app is classified as Low Risk. Default: 1                                                           |
| Medium Risk Threshold (weeks) | If the total effort is at or below this number of calendar weeks, the app is classified as Medium Risk. Above this number, the app is classified as High Risk. Default: 4 |

With the default values, an app is classified as Low Risk up to 80 hours of effort, Medium Risk up to 320 hours, and High Risk above that.

### Related

* [Components with vulnerabilities (COMP\_0001)](https://docs.bluestorm.io/checks/component/comp_0001.md)
* [Max component age (COMP\_0005)](https://docs.bluestorm.io/checks/component/comp_0005.md)
* [Operational Health dashboard](https://docs.bluestorm.io/dashboards/operations.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.bluestorm.io/checks/component/comp_0014.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
